import sys
import random
import numpy as np
"""Takes a set of time courses and randomly selects one to catch the name column and then resamples columns to create new datasets, repetitive selection of the same dataset is allowed"""

sys.argv.pop(0)
testfile = random.choice(sys.argv)
testdata=np.loadtxt(testfile, delimiter='\t', skiprows=1, usecols=[1])
data=np.ndarray(shape=(13,len(testdata)),dtype=object)
initfile = random.choice(sys.argv)
data[0]= np.loadtxt(initfile, delimiter='\t', skiprows=1, usecols=[0],dtype='S16')
genefilename='genenames_'+initfile
genes = open(genefilename,'w')
outputfilename='randomised_'+initfile.replace('.txt','')
np.savetxt(genes, data[0].T, delimiter='\t', newline='\n', fmt='%s')
for set in range(1,37):
    for i in range(1,13):
        file=random.choice(sys.argv)
        data[i] = np.loadtxt(file, delimiter='\t', skiprows=1, usecols=[i])
        dataset = data.T
    outputfile =open(outputfilename+str(set)+'.txt','w')
    np.savetxt(outputfile, dataset, newline='\n', header='Probes\t 0\t 4\t 8\t 12\t 16\t 20\t 24\t 28\t 32\t 36\t 40\t 44',fmt='%s\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f',comments='')