from rpy import *
import numpy as np
import random


def rand_model(number_genes=8400,record_length=12,type='white'):
    """generate the white noise or AR(1) simulation datasets"""
    datasets = {}
    for i in range(number_genes):
        if type == 'white':
            data = r.rnorm(record_length)
        else:
            set_default_mode(NO_CONVERSION)
            ar1 = r.arima_sim(r.list(ar=0.5),n=record_length)
            set_default_mode(BASIC_CONVERSION)
            data = ar1.as_py()
        datasets[type+'_'+str(i)+'_'] = data
    return datasets

def cosine_model_varied(record_length=12):
    """generate cosine wave model data"""
    datasets = {}
    x = np.arange(0,45,4)
    for per in arange(22,28,0.1):
        for pha in range(28):
            for sn in range(1,6,1):
                type = 'sta'
                mea = 10     # mean level of cosine model
                amp = 2     # signal/noise ratio = 1:1
                data = mea +sn*amp*cos(2*np.pi*(x/per-pha/per))+r.rnorm(record_length)
                datasets['%s_%s_%s_%s'%(type,per,pha,sn)] = data
    return datasets

if __name__ == '__main__':
#    for per in arange(23,28,0.5):
        r.set_seed(1)
        if not os.path.exists('LD'):
            os.makedirs('LD')
        for i in range(1,37):
            fou = open('LD/simulations_'+str(i)+'.txt','w')
            w = str(np.arange(0,45,4))
            fou.write('Probes'+'\t'+w[2:-1]+'\n')
            data = cosine_model_varied()
            for name in data:
                value = '\t'.join(map(str,data[name]))
                print >>fou, name+'\t'+value
            randdata = rand_model()
            for name in randdata:
                value = '\t'.join(map(str,randdata[name]))
                print >>fou, name+'\t'+value
#        cosine =  cosine_model_multiple()
#        for name in cosine:
#            value = '\t'.join(map(str,cosine[name]))
#            print >>fou, name+'\t'+value     
