from rpy import *
import numpy as np
import random

def cosine_model_varied(record_length=24):
    """generate cosine wave model data with randomized period"""
    datasets = {}
    x = np.arange(0,94,4)
    per=random.normalvariate(25,3)
    for amp in arange(0,6,0.1):
        for pha in range(28):
            for sn in range(1,6,1):
                type = 'sta'
                mea = 10     # mean level of cosine model
                data = mea +sn*amp*cos(2*np.pi*(x/per-pha/per))+r.rnorm(record_length)
                datasets['%s_%s_%s_%s'%(type,amp,pha,sn)] = data
    return datasets

if __name__ == '__main__':
        r.set_seed(1)
        for i in range(1,73):
            if not os.path.exists('LL_more'):
                os.makedirs('LL_more')
            fou = open('LL_more/simulations_'+str(i)+'.txt','w')
            w = str(np.arange(0,94,4))
            fou.write('Probes'+'\t'+w[2:-1]+'\n')
            data = cosine_model_varied()
            for name in data:
                value = '\t'.join(map(str,data[name]))
                print >>fou, name+'\t'+value